class Engine {
  public : virtual ~Engine( void ) = 0;
};
Engine::~Engine( void ) {};

class Tire {
  public : virtual ~Tire( void ) = 0;
};
Tire::~Tire( void ) {};

class PartsFactory {
  public :
    virtual Engine * createEngine( void ) = 0;
    virtual Tire * createTire( void ) = 0;
    virtual ~PartsFactory( void ) {}
};

class Car {
  protected :
    Engine * engine; Tire * tire;
  public :
    Car( const PartsFactory & factory ) {
        // 
      engine = factory.createEngine();
      tire   = factory.createTire();
        // 
    }
    void RunSimulation( void ) { /*  */ }
};

class Car1Engine : public Engine {};
class Car1Tire   : public Tire {};

class Car1PartsFactory : public PartsFactory {
  public :
    Engine * createEngine( void )
    { return new Car1Engine(); }
    Tire * createTire( void )
    { return new Car1Tire(); }
};

class Car2Engine : public Engine {};
class Car2Tire   : public Tire {};

class Car2PartsFactory : public PartsFactory {
  public :
    Engine * createEngine( void )
    { return new Car2Engine(); }
    Tire * createTire( void )
    { return new Car2Tire(); }
};