interface Engine {}

interface Tire {}

interface PartsFactory {
  Engine createEngine();
  Tire createTire();
}

class Car {
  protected Engine engine;
  protected Tire tire;
  public Car( PartsFactory factory ) {
        // 略
      engine = factory.createEngine();
      tire   = factory.createTire();
        // 略
    }
  public void RunSimulation() { /* 略 */ }
}

class Car1Engine implements Engine {}
class Car1Tire   implements Tire {}

class Car1PartsFactory implements PartsFactory {
  public Engine createEngine() {
    return new Car1Engine();
  }
  public Tire createTire() {
    return new Car1Tire();
  }
}

class Car2Engine implements Engine {}
class Car2Tire   implements Tire {}

class Car2PartsFactory implements PartsFactory {
  public Engine createEngine() {
    return new Car2Engine();
  }
  public Tire createTire() {
    return new Car2Tire();
  }
}