#include <string>    // for string

class LanguageFormatter {
  public :
    virtual void format( std::string & text ) = 0;
    virtual ~LanguageFormatter( void ) {}
};

class TextDocument {
  protected : 
    virtual LanguageFormatter * newFormatter( void ) = 0;
    std::string textdata;
  public :
    void operation( void ) {
        // 
      LanguageFormatter * formatter = newFormatter();
      if( formatter != 0 ) formatter->format( textdata );
        // 
    }
    virtual ~TextDocument( void ) {}
};

class CplusplusFormatter : public LanguageFormatter {
  public :
    void format( std::string & text ) {
      // C++p̃eLXg`s
    }
};

class JavaFormatter : public LanguageFormatter {
  public :
    void format( std::string & text ) {
      // Javap̃eLXg`s
    }
};

class CplusplusDocument : public TextDocument {
  protected :
    LanguageFormatter * newFormatter( void ) {
      return new CplusplusFormatter();
    }
};

class JavaDocument : public TextDocument {
  protected :
    LanguageFormatter * newFormatter( void ) {
      return new JavaFormatter();
    }
};