interface LanguageFormatter {
  void format( StringBuffer text );
}

abstract class TextDocument {
  protected abstract LanguageFormatter newFormatter( );
  protected StringBuffer textdata;
  public final void operation( ) {
      // 略
    LanguageFormatter formatter = newFormatter();
    if(formatter != null) formatter.format( textdata );
      // 略
  }
}

class CplusplusFormatter implements LanguageFormatter {
  public void format( StringBuffer text ) {
    // C++用のテキスト整形を行う
  }
}

class JavaFormatter implements LanguageFormatter {
  public void format( StringBuffer text ) {
    // Java用のテキスト整形を行う
  }
}

class CplusplusDocument extends TextDocument {
  protected LanguageFormatter newFormatter( ) {
    return new CplusplusFormatter();
  }
}

class JavaDocument extends TextDocument {
  protected LanguageFormatter newFormatter( ) {
    return new JavaFormatter();
  }
}