#include <map>
#include <string>
using namespace std;

class GUIPartPrototype {
  public : virtual GUIPartPrototype * clone( void ) = 0;
};

class EditableText : public GUIPartPrototype {
    string text;
  public :
    EditableText( void ) : text( "" ) {}
    EditableText( EditableText & p ) { text = p.text; }
    EditableText * clone( void ) { return new EditableText( *this ); }
};

class CheckBox : public GUIPartPrototype {
    bool on;
  public :
    CheckBox( void ) : on( false ) {}
    CheckBox( CheckBox & p ) { on = p.on; }
    CheckBox * clone( void ) { return new CheckBox( *this ); }
};

class GUIConstructor {
    typedef map<int, GUIPartPrototype*> protomap; protomap prototypes;
  public :
    void addPrototype(int key, GUIPartPrototype* p) {prototypes[ key ] = p;}
    void operation( int key ) {
        // 
      GUIPartPrototype * p = prototypes[ key ]->clone();
        // 
    }
    GUIConstructor( void )
    { prototypes[0] = new EditableText(); prototypes[1] = new CheckBox(); }
    GUIConstructor( GUIConstructor & guic ) {
      protomap::iterator i = guic.prototypes.begin();
      while( i != guic.prototypes.end() )
      { prototypes[ i->first ] = i->second->clone(); i++; }
    }
    GUIConstructor & operator= ( GUIConstructor & guic ) {
      prototypes.clear(); protomap::iterator i = guic.prototypes.begin();
      while( i != guic.prototypes.end() )
      { prototypes[ i->first ] = i->second->clone(); i++; }
      return *this;
    }
};