import java.util.TreeMap; // Java2(JDK1.2)用

interface GUIPartPrototype extends Cloneable {
  public Object clone() throws CloneNotSupportedException;
}

class EditableText implements GUIPartPrototype {
  protected StringBuffer text;
  public EditableText() { text = new StringBuffer(); }
  public Object clone() throws CloneNotSupportedException {
    EditableText instance = (EditableText) super.clone();
    instance.text = new StringBuffer( text.toString() );
    return instance;
  }
}

class CheckBox implements GUIPartPrototype {
  protected boolean on;
  public CheckBox() { on = false; }
  public Object clone() throws CloneNotSupportedException {
    CheckBox instance = (CheckBox) super.clone(); instance.on = on;
    return instance;
  }
}

class GUIConstructor implements Cloneable {
  protected TreeMap prototypes;
  public void addPrototype( int key, GUIPartPrototype p ) {
    prototypes.put( new Integer( key ), p );
  }
  public void operation( int key ) throws CloneNotSupportedException {
      // 略
    GUIPartPrototype p 
      = (GUIPartPrototype)(prototypes.get( new Integer( key ) ));
    p = (GUIPartPrototype)(p.clone());
      // 略
  }
  public GUIConstructor() {
    prototypes = new TreeMap();
    prototypes.put( new Integer( 0 ), new EditableText() );
    prototypes.put( new Integer( 1 ), new CheckBox() );
  }
  public Object clone() throws CloneNotSupportedException {
    GUIConstructor instance = (GUIConstructor) super.clone();
    instance.prototypes = new TreeMap( prototypes );
    return instance;
  }
}