class DrawTool {
    static final int kNonSelected = 0;
    static final int kRectTool    = 1;
    static final int kTextTool    = 2;
    private int tState;

  public DrawTool() { tState = kNonSelected; }
  public void doClick( int x1, int y1 ) { // マウスクリック処理を行う
    // 引数x1, y1にはマウスがクリックされた位置が渡される
    int x2, y2;
    switch( tState )
    {
      case kNonSelected : 
        if( /* クリック位置が矩形描画ツールアイコンか */ ) {
          tState = kRectTool;
        }        
        else if( /* クリック位置がテキスト描画ツールアイコンか */ ) {
          tState = kTextTool;
        }
        break;
      case kRectTool    : // 矩形の描画を開始する
        do {} while( /* マウスクリックが押されていないなら真 */ );
        if( /* クリック位置がドキュメント上の場合 */ ) {
          // マウスクリックの位置をx2とy2に格納し，点(x1,y1)
          // を矩形のひとつの角，その角と対角関係にある別の角
          // を点(x2, y2)として，矩形を描画する
        }
        else if( /* クリック位置がテキスト描画ツールアイコンか */ ) {
          tState = kTextTool;
        }
        else if( /* クリックで描画ツール選択が解除になるか */ ) {
          tState = kNonSelected;
        }
        break;
      case kTextTool    :
        // テキスト入力フィールドを生成する
        do { /* テキスト入力を行う */ } 
          while(/* テキストフィールド外でのクリックではないなら真 */);
        // テキスト入力処理を終了する
        if( /* クリック位置が矩形描画ツールアイコンか */ ) {
          tState = kRectTool;
        }        
        else if( /* クリックで描画ツール選択が解除になるか */ ) {
          tState = kNonSelected;
        }
        break;  
    }
  }
    
  public void doHelp() { // ヘルプ機能を呼び出す
    switch( tState )
    {
      case kNonSelected : 
        // 全般的な事項に関するヘルプ画面を表示する
        break;
      case kRectTool :
        // 矩形描画ツールの使い方を説明するヘルプ画面を表示する
        break;
      case kTextTool : 
        // テキスト描画ツールの使い方を説明するヘルプ画面を表示する
        break;
    }
  }
}