#include <string>
#include <map>
using namespace std;

class IntrinsicState { /*  */ };
class ExtrinsicState { /*  */ };
class AllState {
  public :
    IntrinsicState intrinsic;
    ExtrinsicState extrinsic;
};

class FlyweightFactory;

class Flyweight {
  public :
    virtual void operation( ExtrinsicState & es ) = 0;
    virtual ~Flyweight( void ) {}
};

class ConcreteFlyweight : public Flyweight {
    friend FlyweightFactory;
    IntrinsicState is;
    ConcreteFlyweight( void ) {}
    ConcreteFlyweight( ConcreteFlyweight & cf ) { is = cf.is; }
    ConcreteFlyweight & operator=( ConcreteFlyweight & cf ) {
        if( this != &cf ) is = cf.is;
        return *this;
    }
    ~ConcreteFlyweight( void ) {}
  public :
    void operation( ExtrinsicState & es ) { /*  */ }
};

class UnsharedConcreteFlyweight : public Flyweight {
    AllState as;
  public :
    void operation( ExtrinsicState & es ) { /*  */ }
};

class FlyweightFactory {
    typedef map< string, ConcreteFlyweight* > FlyweightMap;
    FlyweightMap flyweights;
  public :
    ConcreteFlyweight * getFlyweight( const string & key ) {
      FlyweightMap::iterator i = flyweights.find( key );
      if( i != flyweights.end() ) return i->second;
      else {
        ConcreteFlyweight * temp = new ConcreteFlyweight();
        if( temp != 0 ) flyweights[ key ] = temp;
        return temp;
      }
    }
    UnsharedConcreteFlyweight * getUnsharedFW( void ) {
      return new UnsharedConcreteFlyweight();
    }
};