import java.util.*;

class Data extends Observable {
  private int value = 1;
  public void operation() { ++value; setChanged(); notifyObservers(); }
  public int getState() { return value; }
}

class Graph implements Observer {
  private Data data;
  public Graph( Data d ) { data = d; d.addObserver( this ); }
  public void update( Observable o, Object arg ) {
    if( data != null && (o == data) )
      for( int i = 0; i < data.getState(); i++ )
        System.out.print( "*" );
    System.out.println();
  }
}

public class Observer1 {
  public static void main( String args[] ) {
    Data d1 = new Data(); Data d2 = new Data(); d2.operation(); 
    Graph g1 = new Graph( d1 ); Graph g2 = new Graph( d2 );
    d1.operation(); d2.operation(); 
  }
}