#include <iostream>
#include <vector>
using namespace std;

class Component;
// O̒`
class CompositeException       : public exception {};
class NonCompositeException    : public CompositeException {};
class ElementNotFoundException : public CompositeException {};
class NotAddedException        : public CompositeException {
    Component * notAddedComponent;
  public :
    NotAddedException( Component * c ) : notAddedComponent( c ) {}
    Component * getNotAdded( void ) { return notAddedComponent; }
};

typedef vector<Component *>::iterator iter;
class Component {
  public :
    virtual void operation( void ) = 0;
    virtual void add( Component * c )
      throw ( NonCompositeException, NotAddedException )
    { throw NotAddedException( c ); }
    virtual void remove( Component * c )
      throw ( NonCompositeException, ElementNotFoundException )
    { throw NonCompositeException(); }
    virtual iter getChild( iter * iend ) throw ( NonCompositeException )
    { throw NonCompositeException(); }
    virtual ~Component( void ) {}
};

class Composite : public Component {
    vector<Component *> children;
    iter findchild( Component * c )
    { return find( children.begin(), children.end(), c ); }
  public :
    void operation( void ) {
      for( iter i = children.begin(); i != children.end(); i++ )
        (*i)->operation();
    }
    void add( Component * c ) {
      try {
    	  children.push_back( c );
    	}
    	catch( bad_alloc ) { throw NotAddedException( c ); }
    }
    void remove( Component * c ) {
      iter i = findchild( c );
      if( i == children.end() ) throw ElementNotFoundException();
    	children.erase( i );
    }
    iter getChild( iter * iend ) {
      iter i = children.end(); if( iend != 0 ) *iend = i; 
      return children.begin();
    }
};

template<class T> class Leaf : public Component {
    T value;
  public :
    Leaf( const T & v ) : value( v ) {}
    void operation( void ) { cout << value << endl; }
};

int main( void ) {	
  Component * node1 = new Composite(), * node2 = new Composite(),
            * node3 = new Composite();
  Component * node4 = new Leaf<int>( 1 ), * node5 = new Leaf<int>( 2 ),
            * node6 = new Leaf<int>( 3 ), * node7 = new Leaf<int>( 4 );
  // ȉ[ŨR[h
  try {
    node2->add( node4 ); node2->add( node5 ); node3->add( node6 );
    node3->add( node7 ); node1->add( node2 ); node1->add( node3 );
    node1->operation();  cout << endl;
    node1->remove( node3 ); node1->operation();
  }
  catch( NotAddedException & e ) {
    // vfǉłȂ
    Component * c = e.getNotAdded(); // ǉłȂvf߂
  }
  catch( NonCompositeException & e )
  { /* CompositeIuWFNgɈ@ȃ\bhĂяo */ }
  catch( ElementNotFoundException & e )
  { /* w肳ꂽvfȂ */ }
  catch( CompositeException & e ) { /* ̗̑Oɑ΂鏈 */ }
  return 0;
}