#include <iostream>
#include <vector>
using namespace std;

class Component {
  public :
    virtual void operation( void ) = 0;
    virtual ~Component( void ) {}
};

typedef vector<Component *>::iterator iter;
class Composite : public Component {
    vector<Component *> children;
    iter findchild( Component * c )
    { return find( children.begin(), children.end(), c ); }
  public :
    void operation( void ) {
      for( iter i = children.begin(); i != children.end(); i++ )
        (*i)->operation();
    }
    bool add( Component * c ) {
      try {
    	  children.push_back( c ); return true;
    	}
    	catch( bad_alloc ) { return false; }
    }
    bool remove( Component * c ) {
      iter i = findchild( c );
      if( i == children.end() ) return false;
    	children.erase( i ); return true;
    }
    iter getChild( iter * iend ) {
      iter i = children.end(); if( iend != 0 ) *iend = i; 
      return children.begin();
    }
};

template<class T> class Leaf : public Component {
    T value;
  public :
    Leaf( const T & v ) : value( v ) {}
    void operation( void ) { cout << value << endl; }
};

int main( void ) {	
  Component * node1 = new Composite(), * node2 = new Composite(),
            * node3 = new Composite();
  Component * node4 = new Leaf<int>( 1 ), * node5 = new Leaf<int>( 2 ),
            * node6 = new Leaf<int>( 3 ), * node7 = new Leaf<int>( 4 );
  // ȉ[ŨR[h
  Composite * temp = 0;
  if( temp = dynamic_cast<Composite * >(node2) ) temp->add( node4 );
  if( temp = dynamic_cast<Composite * >(node2) ) temp->add( node5 );
  if( temp = dynamic_cast<Composite * >(node3) ) temp->add( node6 );
  if( temp = dynamic_cast<Composite * >(node3) ) temp->add( node7 );
  if( temp = dynamic_cast<Composite * >(node1) ) temp->add( node2 );
  if( temp = dynamic_cast<Composite * >(node1) ) temp->add( node3 );
  node1->operation(); cout << endl;
  if( temp = dynamic_cast<Composite * >(node1) ) temp->remove( node3 );
  node1->operation();
  return 0;
}