import java.util.*; // for Java2 (JDK 1.2.x)

abstract class Component {
  public abstract void operation();
}

class Composite extends Component {
  private Vector children = new Vector();
  public void operation() {
    Iterator i = children.iterator();
    while( i.hasNext() ) ((Component)(i.next())).operation();
  }
  public boolean add( Component c ) { return children.add( c ); }
  public boolean remove( Component c ) { return children.remove( c ); }
  public Iterator getChild() {
    return children.iterator();
  }
}

class Leaf extends Component {
  private Object value;
  public Leaf( Object v ) { value = v; }
  public void operation() { System.out.println( value ); }
}

public class Composite2 {
  public static void main( String args[] ) {
    Component node1 = new Composite(), node2 = new Composite(),
              node3 = new Composite();
    Component node4 = new Leaf( new Integer( 1 ) ), 
              node5 = new Leaf( new Integer( 2 ) ),
              node6 = new Leaf( new Integer( 3 ) ),
              node7 = new Leaf( new Integer( 4 ) );
    // 以下がユーザのコード部分
    try {
      ((Composite)node2).add( node4 ); ((Composite)node2).add( node5 ); 
      ((Composite)node3).add( node6 ); ((Composite)node3).add( node7 ); 
      ((Composite)node1).add( node2 ); ((Composite)node1).add( node3 );
      node1.operation();  System.out.println();
      ((Composite)node1).remove( node3 ); node1.operation();
    }
    catch( ClassCastException e ) { /* 間違ったキャストを行った場合 */ }
  }
}