#include <iostream>
using namespace std;

class Expression {
  public : 
    virtual int interpret( void ) = 0;
    virtual ~Expression( void ) {}
};

class AddExpression : public Expression {
    Expression * left, * right;
  public :
    AddExpression( Expression * left, Expression * right ) 
     : left( left ), right( right ) {}
    int interpret( void ) { 
      return left->interpret() + right->interpret();
    }
};

class Number : public Expression {
    int n;
  public :
    Number( int n ) : n( n ) {}
    int interpret( void ) { return n; }
};

int main( void ) {
  Number * node4 = new Number( 1 ), * node5 = new Number( 2 ), 
         * node6 = new Number( 3 ), * node7 = new Number( 4 );
  AddExpression * node2 = new AddExpression( node4, node5 ),
                * node3 = new AddExpression( node6, node7 ),
                * node1 = new AddExpression( node2, node3 );
  cout << node1->interpret() << endl;
  return 0;
}