#include <iostream>
#include <vector>
#include <string>
using namespace std;

class ClickAction { // NbNsIuWFNg
    string actionString;
  public :
    ClickAction( char * str ) : actionString( str ) {}
    virtual ~ClickAction( void ) {}
    void doAction( void ) { cout << actionString << endl; }
};

class Component {
  protected :
    ClickAction * action; // NbNIuWFNgo^ϐ
    Component * parent; // Chain of Reactionp^[ׂ̈̎ȎQ
  public :
    Component( void ) : parent( 0 ), action( 0 ) {}
    virtual ~Component( void ) = 0;
    void setParent( Component * p ) { parent = p; }
    virtual void doClick( void ) { if( parent != 0 ) parent->doClick(); }
    void setAction( ClickAction * ca ) { action = ca; }
    virtual void add( Component * c ) {}
};
Component::~Component( void ) {}

class Graphic : public Component {
    vector<Component *> children;
  public :
    void doClick( void )
    { if( action != 0 ) action->doAction(); else Component::doClick(); }
    void add( Component * c )
    { children.push_back( c ); c->setParent( this ); }
};

class Button : public Component {
  public : void doClick( void )
    { if( action != 0 ) action->doAction(); else Component::doClick(); }
};
class Text : public Component {
  public : void doClick( void )
    { if( action != 0 ) action->doAction(); else Component::doClick(); }
};

int main( void ) {
  Component * graphic1 = new Graphic(), * graphic2 = new Graphic(),
            * graphic3 = new Graphic(), * graphic4 = new Graphic(),
            * graphic5 = new Graphic(), * graphic6 = new Graphic(),
            * graphic7 = new Graphic(), * graphic8 = new Graphic();
  Component * text1 = new Text(), * text2 = new Text(), * text3 = new Text(),
            * text4 = new Text(), * text5 = new Text();
  Component * button1 = new Button();
  graphic1->add(text1); graphic1->add(button1); graphic1->add(graphic2); 
  graphic2->add( graphic3 ); graphic2->add( graphic5 ); 
  graphic2->add( graphic7 ); graphic2->add( text2 );
  graphic3->add( graphic4 ); graphic3->add( text3 ); 
  graphic5->add( graphic6 ); graphic3->add( text4 ); 
  graphic7->add( graphic8 ); graphic3->add( text5 ); 
  
  // ȉ6s͎ۂɂ̓\tgEFAsɃf[^҂s
  graphic1->setAction( new ClickAction( "About this data..." ) );
  graphic2->setAction( new ClickAction( "About the solar system..." ) );
  graphic3->setAction( new ClickAction( "About Mercury..." ) );
  graphic5->setAction( new ClickAction( "About Venus..." ) );
  graphic7->setAction( new ClickAction( "About Earth..." ) );
  button1->setAction(  new ClickAction( "next planets..." ) );
  // eLXg3doClick()bZ[W𑗐M
  text3->doClick();
  return 0;
}