import java.util.Vector;

class ClickAction { // クリック動作を行うオブジェクト
  private String actionString = "";
  public ClickAction( String str ) { actionString = str; }
  public void doAction() { System.out.println( actionString ); }
}

abstract class Component {
  protected ClickAction action; // クリック動作オブジェクトを登録する変数
  protected Component parent; // Chain of Reactionパターンの為の自己参照
  public Component() { parent = null; action = null; }
  public void setParent( Component p ) { parent = p; }
  public void doClick() { if( parent != null ) parent.doClick(); }
  public void setAction( ClickAction ca ) { action = ca; }
  public void add( Component c ) {}
}

class Graphic extends Component {
  private Vector children = new Vector();
  public void doClick()
  { if( action != null ) action.doAction(); else super.doClick(); }
  public void add( Component c )
  { children.addElement( c ); c.setParent( this ); }
}

class Button extends Component {
  public void doClick()
    { if( action != null ) action.doAction(); else super.doClick(); }
}
class Text extends Component {
  public void doClick()
    { if( action != null ) action.doAction(); else super.doClick(); }
}

public class ChainofResponsibility {
  public static void main(String args[]) {
    Component graphic1 = new Graphic(), graphic2 = new Graphic(),
              graphic3 = new Graphic(), graphic4 = new Graphic(),
              graphic5 = new Graphic(), graphic6 = new Graphic(),
              graphic7 = new Graphic(), graphic8 = new Graphic();
    Component text1 = new Text(), text2 = new Text(), text3 = new Text(),
              text4 = new Text(), text5 = new Text();
    Component button1 = new Button();
    graphic1.add(text1); graphic1.add(button1); graphic1.add(graphic2); 
    graphic2.add( graphic3 ); graphic2.add( graphic5 ); 
    graphic2.add( graphic7 ); graphic2.add( text2 );
    graphic3.add( graphic4 ); graphic3.add( text3 ); 
    graphic5.add( graphic6 ); graphic3.add( text4 ); 
    graphic7.add( graphic8 ); graphic3.add( text5 ); 
  
  // 以下の6行分は実際にはソフトウェア実行時にデータ制作者が行う
    graphic1.setAction( new ClickAction( "About this data..." ) );
    graphic2.setAction( new ClickAction( "About the solar system..." ) );
    graphic3.setAction( new ClickAction( "About Mercury..." ) );
    graphic5.setAction( new ClickAction( "About Venus..." ) );
    graphic7.setAction( new ClickAction( "About Earth..." ) );
    button1.setAction(  new ClickAction( "next planets..." ) );
  // テキスト3にdoClick()メッセージを送信
    text3.doClick();
	}
}