import java.util.*; // Java2 (JDK 1.2 or later)

class PatrolMediator { // パトロールオブジェクト間の調停を行う
  private Vector pm; Vector pcs;
  public void addPatroler( PatrolMan p ) { pm.add(p); } // pをpmに登録する
  public void addPatroler( PatrolCar p ) { pm.add(p); } // pをpcsに登録する  
  public void controlPatrol( Patroler p ) { // pに移動を指示する
    // pmとpcsに登録されている全てのオブジェクトの位置から，
    // オブジェクトpが移動すべき位置を計算して，pのmove()
    // を呼び出して適切な移動を指示する
  }
  public void reinforcement( Patroler p ) { // pに増援を送る
    // pの近くにいるオブジェクトをpに向かって移動させる
  } 
}

abstract class Colleague { // 抽象クラスColleague
  protected PatrolMediator mediator;
}

class Patroler extends Colleague { // パトロールオブジェクトのクラス
  protected double x, y;  // 現在いる位置
  public Patroler( PatrolMediator pm ) { mediator = pm; x = y = 0.0; }
  public void move( double dx, double dy ) { x += dx; y += dy; } // 移動
  public void ask() { mediator.controlPatrol( this ); }   // 指示を仰ぐ
  public void wander() { /* 略 */ }   // 自発的に少しの距離だけ移動する
  public void callAnotherPatroler()   // 他の仲間を呼ぶ
  { mediator.reinforcement( this ); }
}

class PatrolMan extends Patroler { // 徒歩のパトロール員
  public PatrolMan( PatrolMediator m ) { super( m ); };
}
class PatrolCar extends Patroler { // パトロールカー
  public PatrolCar( PatrolMediator m ) { super( m ); };
}